<?php
/**
 * PostNuke Application Framework
 *
 * @copyright (c) 2001, PostNuke Development Team
 * @link http://www.postnuke.com
 * @version $Id: pnadmin.php 196 2006-05-14 23:01:22Z chestnut $
 * @license GNU/GPL - http://www.gnu.org/copyleft/gpl.html
 */

function GoogleMap_admin_main()
{

    return GoogleMap_admin_markers();

}

function GoogleMap_admin_config()
{

    if (!pnSecAuthAction(0, 'GoogleMap::', '::', ACCESS_ADMIN)) {
        return pnVarPrepHTMLDisplay(_MODULENOAUTH);
    }

    $pnRender = new pnRender('GoogleMap');
    $pnRender->caching = false;
    $pnRender->force_compile = true;

    $maptypes = array('G_HYBRID_MAP'    => _GM_MAPTYPE_MIXT,
                      'G_SATELLITE_MAP' => _GM_MAPTYPE_SATELLITE,
                      'G_NORMAL_MAP'    => _GM_MAPTYPE_PLAN);

    $yesnooptions = array(0 => _NO,
                          1 => _YES);

    $zoomlevels = array();
    for ($x = 0; $x < 20; $x++) {
        $zoomlevels[$x] = $x;
    }

    $pnRender->Assign('modvars',      pnModGetVar('GoogleMap'));
    $pnRender->Assign('maptypes',     $maptypes);
    $pnRender->Assign('zoomlevels',   $zoomlevels);
    $pnRender->Assign('yesnooptions', $yesnooptions);

    return $pnRender->fetch('GoogleMap_admin_config.tpl');

}

function GoogleMap_admin_updateconfig()
{

    if (!pnSecAuthAction(0, 'GoogleMap::', '::', ACCESS_ADMIN)) {
        return pnVarPrepHTMLDisplay(_MODULENOAUTH);
    }

    $googlekey        = pnVarCleanFromInput('googlekey');
    $initiallat       = pnVarCleanFromInput('initiallat');
    $initiallong      = pnVarCleanFromInput('initiallong');
    $mapheight        = pnVarCleanFromInput('mapheight');
    $mapwidth         = pnVarCleanFromInput('mapwidth');
    $initialzoomlevel = pnVarCleanFromInput('initialzoomlevel');
    $initialmaptype   = pnVarCleanFromInput('initialmaptype');
    $showuserlist     = pnVarCleanFromInput('showuserlist');
    $showusersonline  = pnVarCleanFromInput('showusersonline');

    $modvars = pnModGetVar('GoogleMap');

    // Keeping default if values are empty
    if (!empty($initiallat)) {
        $modvars['initiallat'] = $initiallat;
    }
    if (!empty($initiallong)) {
        $modvars['initiallong'] = $initiallong;
    }
    if (!empty($mapheight)) {
        $modvars['mapheight'] = $mapheight;
    }
    if (!empty($mapwidth)) {
        $modvars['mapwidth'] = $mapwidth;
    }
    if (!empty($initialzoomlevel)) {
        $modvars['initialzoomlevel'] = $initialzoomlevel;
    }
    if (!empty($initialmaptype)) {
        $modvars['initialmaptype'] = $initialmaptype;
    }
    if (!empty($googlekey)) {
        $modvars['googlekey'] = $googlekey;
    } else {
        $modvars['googlekey'] = '';
    }
    if (in_array($showuserlist, range(0, 1))) {
        $modvars['showuserlist'] = $showuserlist;
    }
    if (in_array($showusersonline, range(0, 1))) {
        $modvars['showusersonline'] = $showusersonline;
    }

    while(list($varname, $varvalue) = each($modvars)) {
        pnModSetVar('GoogleMap', $varname, $varvalue);
    }

    pnSessionSetVar('statusmsg', pnVarPrepHTMLDisplay(_GM_CONFIGUPDATED));

    return pnRedirect(pnModUrl('GoogleMap', 'admin', 'main'));

}

function GoogleMap_admin_markers()
{

    if (!pnSecAuthAction(0, 'GoogleMap::', '::', ACCESS_ADMIN)) {
        return pnVarPrepHTMLDisplay(_MODULENOAUTH);
    }

    $pnRender = new pnRender('GoogleMap');
    $pnRender->caching = false;
    $pnRender->force_compile = true;

    $items    = pnModAPIFunc('GoogleMap', 'user', 'getall',         array());
    $specials = pnModAPIFunc('GoogleMap', 'user', 'getallspecials', array());

    $pnRender->Assign('items',    $items);
    $pnRender->Assign('specials', $specials);

    return $pnRender->fetch('GoogleMap_admin_markers.tpl');

}

function GoogleMap_admin_addspecial()
{

    if (!pnSecAuthAction(0, 'GoogleMap::', '::', ACCESS_ADMIN)) {
        return pnVarPrepHTMLDisplay(_MODULENOAUTH);
    }

    $pnRender = new pnRender('GoogleMap');
    $pnRender->caching = false;
    $pnRender->force_compile = true;

    $handle = opendir('modules/GoogleMap/pnimages/specials');
    while ($file = readdir($handle)) {
        $filelist[] = $file;
    }
    asort($filelist);
    while (list ($key, $file) = each ($filelist)) {
        if (ereg('.png', $file)) {
            //$specialfiles .= '<option label="'.$file.'" value="specials/'.$file.'">'.$file.'</option>';
            $specialfiles['small/'.$file] = $file;
        }
    }

    $pnRender->Assign('icons',  $specialfiles);
    $pnRender->Assign('action', 'add');

    return $pnRender->fetch('GoogleMap_admin_addspecial.tpl');

}

function GoogleMap_admin_modifyspecial()
{

    if (!pnSecAuthAction(0, 'GoogleMap::', '::', ACCESS_ADMIN)) {
        return pnVarPrepHTMLDisplay(_MODULENOAUTH);
    }

    $pnRender = new pnRender('GoogleMap');
    $pnRender->caching = false;
    $pnRender->force_compile = true;

    $mid      = pnVarCleanFromInput('mid');
    $special  = pnVarCleanFromInput('special');

    if (empty($mid) || !is_numeric($mid)) {
        pnSessionSetVar('errormsg', 'Error: Empty Marker ID');
        pnRedirect(pnModUrl('GoogleMap', 'admin', 'main'));
    }

    if ($special == 1) {
        $type   = 'admin';
        $func   = 'getspecial';
        $object = 'mid';
    } else {
        $type   = 'user';
        $func   = 'get';
        $object = 'objectid';
    }

    $item = pnModAPIFunc('GoogleMap', $type, $func, array($object => $mid));

    if (!$item) {
        pnSessionSetVar('errormsg', 'Error: No such Marker');
        pnRedirect(pnModUrl('GoogleMap', 'admin', 'main'));
    }

    if ($item['uid'] > 1) {
        $item['title'] = pnUserGetVar('uname', $item['uid']);
        $handle = opendir('modules/GoogleMap/pnimages');
    } else {
        $handle = opendir('modules/GoogleMap/pnimages/specials');
    }

    while ($file = readdir($handle)) {
        $filelist[] = $file;
    }
    asort($filelist);
    while (list ($key, $file) = each ($filelist)) {
        if (ereg('.png', $file) && ereg('marker_', $file)) {
            //$specialfiles .= '<option label="'.$file.'" value="specials/'.$file.'">'.$file.'</option>';
            $specialfiles[$file] = $file;
        }
    }

    $pnRender->Assign('icons',  $specialfiles);
    $pnRender->Assign('action', 'update');
    $pnRender->Assign($item);

    return $pnRender->fetch('GoogleMap_admin_addspecial.tpl');

}

function GoogleMap_admin_updatespecial()
{

    if (!pnSecAuthAction(0, 'GoogleMap::', '::', ACCESS_ADMIN)) {
        return pnVarPrepHTMLDisplay(_MODULENOAUTH);
    }

    $uid        = pnVarCleanFromInput('uid');
    $mid        = pnVarCleanFromInput('mid');
    $title      = pnVarCleanFromInput('title');
    $action     = pnVarCleanFromInput('action');
    $longitude  = pnVarCleanFromInput('longitude');
    $latitude   = pnVarCleanFromInput('latitude');
    $msg        = pnVarCleanFromInput('msg');
    $icon       = pnVarCleanFromInput('icon');

    if (empty($longitude) || empty($latitude)) {
        pnSessionSetVar('errormsg', 'Wrong coordinates');
        return pnRedirect(pnModUrl('GoogleMap', 'user', 'main'));
    }

    // Check if the guy is already mapped
    if ($action == 'add') {
        //$ismapped = pnModAPIFunc('GoogleMap', 'user', 'ismapped', array('uid' => $uid));
        if ($ismapped) {
            pnSessionSetVar('errormsg', 'Already mapped');
            return pnRedirect(pnModUrl('GoogleMap', 'admin', 'addspecial'));
        }
    }

    if ($action == 'add') {
        $type = 'user';
        $func = 'update';
    } else {
        $type = 'admin';
        $func = 'updatespecial';
    }

    $result = pnModAPIFunc('GoogleMap', $type, $func, array('action'    => $action,
                                                            'mid'       => $mid,
                                                            'uid'       => $uid,
                                                            'longitude' => $longitude,
                                                            'latitude'  => $latitude,
                                                            'msg'       => $msg,
                                                            'title'     => $title,
                                                            'icon'      => $icon));

    if ($result == false) {
        pnSessionSetVar('errormsg', 'Error updating markers');
    } else {
        pnSessionSetVar('statusmsg', _GM_COORDSUPDATED);
    }

    return pnRedirect(pnModUrl('GoogleMap', 'admin', 'markers'));

}

function GoogleMap_admin_deletemarker()
{

    if (!pnSecAuthAction(0, 'GoogleMap::', '::', ACCESS_ADMIN)) {
        return pnVarPrepHTMLDisplay(_MODULENOAUTH);
    }

    $pnRender = new pnRender('GoogleMap');
    $pnRender->caching = false;
    $pnRender->force_compile = true;

    $mid    = pnVarCleanFromInput('mid');
    $tag    = pnVarCleanFromInput('tag');
    $submit = pnVarCleanFromInput('submit');

    if (empty($mid) || !is_numeric($mid)) {
        pnSessionSetVar('errormsg', 'Error: Empty Marker ID');
        pnRedirect(pnModUrl('GoogleMap', 'admin', 'specials'));
    }

    $item = pnModAPIFunc('GoogleMap', 'admin', 'getspecial', array('mid' => $mid));

    if (!$item) {
        pnSessionSetVar('errormsg', 'Error: No such Marker');
        pnRedirect(pnModUrl('GoogleMap', 'admin', 'specials'));
    }

    if (!empty($submit)) {
        if (!empty($tag)) {
            if (pnModAPIFunc('GoogleMap', 'admin', 'deletemarker', array('mid' => $mid))) {
                pnSessionSetVar('statusmsg', 'Marker deleted');
                return pnRedirect(pnModUrl('GoogleMap', 'admin', 'main'));
            } else {
                pnSessionSetVar('errormsg', 'Error While deleting marker');
                return pnRedirect(pnModUrl('GoogleMap', 'admin', 'main'));
            }
        } else {
            pnSessionSetVar('errormsg', 'You must check the "Confirm checkbox"');
            return pnRedirect(pnModUrl('GoogleMap', 'admin', 'deletemarker', array('mid' => $mid)));
        }
    }

    if ($item['uid'] == -1) {
        $item['icon'] = 'specials/'.$item['icon'];
    }

    $pnRender->Assign($item);

    return $pnRender->fetch('GoogleMap_admin_deletemarker.tpl');

}

?>