<?php
/**
 * PostNuke Application Framework
 *
 * @copyright (c) 2001, PostNuke Development Team
 * @link http://www.postnuke.com
 * @version $Id: pnadminapi.php 191 2006-05-14 21:19:13Z chestnut $
 * @license GNU/GPL - http://www.gnu.org/copyleft/gpl.html
 */

function GoogleMap_adminapi_getspecial($args)
{

    if (!isset($args['mid']) || !is_numeric($args['mid'])) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['googlemap_markers'];
    $col = $pntable['googlemap_markers_column'];

    $sql = "SELECT $col[mid],
                   $col[title],
                   $col[uid],
                   $col[lat],
                   $col[long],
                   $col[msg],
                   $col[icon]
            FROM   $tbl
            WHERE  $col[mid] = '".pnVarPrepForStore($args['mid'])."'";

    $result =& $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "Error: ".$dbconn->ErrorMsg());
        return false;
    }

    $item = array();

    list($mid, $title, $uid, $lat, $long, $msg, $icon) = $result->fields;

    $item = array('mid'       => $mid,
                  'title'     => $title,
                  'uid'       => $uid,
                  'latitude'  => $lat,
                  'longitude' => $long,
                  'msg'       => $msg,
                  'icon'      => $icon);

    return $item;

}

function GoogleMap_adminapi_updatespecial($args)
{

    $action     = $args['action'];
    $mid        = $args['mid'];
    $longitude  = $args['longitude'];
    $latitude   = $args['latitude'];
    $msg        = $args['msg'];
    if (isset($args['icon']) && !empty($args['icon'])) {
        $icon = $args['icon'];
    } else {
        $icon = 'marker_point.png';
    }
    if (!isset($args['title'])) {
        $title = '';
    } else {
        $title = $args['title'];
    }

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['googlemap_markers'];
    $col = $pntable['googlemap_markers_column'];

    $sql = "UPDATE $tbl
            SET    $col[title]  = '".pnVarPrepForStore($title)."',
                   $col[lat]    = '".pnVarPrepForStore($latitude)."',
                   $col[long]   = '".pnVarPrepForStore($longitude)."',
                   $col[msg]    = '".pnVarPrepForStore($msg)."',
                   $col[icon]   = '".pnVarPrepForStore($icon)."'
            WHERE  $col[mid]    = '".pnVarPrepForStore($mid)."'";


    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        //echo $dbconn->ErrorMsg(); exit;
        pnSessionSetVar('errormsg', "Error: ".$dbconn->ErrorMsg());
        return false;
    }

    return true;

}

function GoogleMap_adminapi_deletemarker($args)
{

    $mid = $args['mid'];

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['googlemap_markers'];
    $col = $pntable['googlemap_markers_column'];

    $sql = "DELETE FROM $tbl
            WHERE       $col[mid] = '".pnVarPrepForStore($mid)."'";


    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        //echo $dbconn->ErrorMsg(); exit;
        pnSessionSetVar('errormsg', "Error: ".$dbconn->ErrorMsg());
        return false;
    }

    return true;

}

function GoogleMap_adminapi_temp()
{

    return true;

}

?>