<?php
/**
 * PostNuke Application Framework
 *
 * @copyright (c) 2001, PostNuke Development Team
 * @link http://www.postnuke.com
 * @version $Id: pninit.php 199 2006-05-14 23:36:33Z chestnut $
 * @license GNU/GPL - http://www.gnu.org/copyleft/gpl.html
 */

function GoogleMap_init()
{

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = &$pntable['googlemap_markers'];
    $col = &$pntable['googlemap_markers_column'];

    $dict = &NewDataDictionary($dbconn);

    $taboptarray =& pnDBGetTableOptions();

    $flds = "
        $col[mid]      I        AUTOINCREMENT PRIMARY,
        $col[title]    C(100)   NOTNULL DEFAULT '',
        $col[uid]      I(11)    NOTNULL DEFAULT 0,
        $col[lat]      F        NOTNULL DEFAULT 0.0,
        $col[long]     F        NOTNULL DEFAULT 0.0,
        $col[msg]      C(200)   NOTNULL DEFAULT '',
        $col[icon]     C(100)   NOTNULL DEFAULT 'marker_point.png'
    ";

    $sqlarray = $dict->CreateTableSQL($tbl, $flds, $taboptarray);

    if ($dict->ExecuteSQLArray($sqlarray) != 2) {
        pnSessionSetVar('errormsg', _CREATETABLEFAILED.' - '.$dbconn->ErrorMsg());
        return false;
    }

    pnModSetVar('GoogleMap', 'googlekey',         '');
    pnModSetVar('GoogleMap', 'initiallat',        48.859294);
    pnModSetVar('GoogleMap', 'initiallong',       2.343521);
    pnModSetVar('GoogleMap', 'mapheight',         500);
    pnModSetVar('GoogleMap', 'mapwidth',          700);
    pnModSetVar('GoogleMap', 'initialzoomlevel',  5);
    pnModSetVar('GoogleMap', 'initialmaptype',    'G_HYBRID_MAP');
    pnModSetVar('GoogleMap', 'showuserlist',      0);
    pnModSetVar('GoogleMap', 'showusersonline',   0);
    pnModSetVar('GoogleMap', 'modulestylesheet',  'googlemap.css');

    return true;

}

function GoogleMap_upgrade($oldversion)
{

    switch($oldversion) {
        case 1.0:
            return GoogleMap_upgrade(1.1);
        case 1.1:
            $dbconn  = pnDBGetConn(true);
            $pntable = pnDBGetTables();

            $tbl = &$pntable['googlemap_markers'];
            $col = &$pntable['googlemap_markers_column'];

            $dict = &NewDataDictionary($dbconn);

            //$taboptarray =& pnDBGetTableOptions();

            $flds = "
                $col[title]    C(100)   NOTNULL DEFAULT '',
                $col[msg]      C(200)   NOTNULL DEFAULT '',
                $col[icon]     C(100)   NOTNULL DEFAULT 'marker_point.png'
            ";

            $sqlarray = $dict->AddColumnSQL($tbl, $flds);

            if ($dict->ExecuteSQLArray($sqlarray) != 2) {
                pnSessionSetVar('errormsg', _GM_UPDATETABLE_FAILED.' - '.$dbconn->ErrorMsg());
                return false;
            }

            pnModSetVar('GoogleMap', 'showuserlist',      0);
            pnModSetVar('GoogleMap', 'showusersonline',   0);

            return GoogleMap_upgrade(2.0);
        case 2.0:
            // Code to upgrade from version 2.0 goes here
            break;
    }

    return true;

}

function GoogleMap_delete()
{

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl  = &$pntable['googlemap_markers'];

    $dict = &NewDataDictionary($dbconn);

    $sqlarray = $dict->DropTableSQL($tbl);

    if ($dict->ExecuteSQLArray($sqlarray) != 2) {
        pnSessionSetVar('errormsg', _DROPTABLEFAILED);
        return false;
    }

    pnModDelVar('GoogleMap');

    return true;

}

?>