<?php
/**
 * PostNuke Application Framework
 *
 * @copyright (c) 2001, PostNuke Development Team
 * @link http://www.postnuke.com
 * @version $Id: pnuser.php 191 2006-05-14 21:19:13Z chestnut $
 * @license GNU/GPL - http://www.gnu.org/copyleft/gpl.html
 */

function GoogleMap_user_main()
{

    if (!pnSecAuthAction('GoogleMap::', '::', ACCESS_OVERVIEW)) {
        return pnVarPrepHTMLDisplay(_MODULENOAUTH);
    }

    $modvars = pnModGetVar('GoogleMap');

    if (!isset($modvars['googlekey']) || empty($modvars['googlekey'])) {
        return pnVarPrepForDisplay(_GM_NOGOOGLEKEYINSTALLED);
    }

    $pnRender = new pnRender('GoogleMap');
    $pnRender->caching = false;
    $pnRender->force_compile = true;

    $show     = false;
    $ismapped = false;
    $canadd   = false;
    $markers  = array();
    $specials = array();
    $onlines  = array();

    if (pnSecAuthAction('GoogleMap::', '::', ACCESS_ADD)) {
        // Can add markers
        $canadd = true;
    }

    if (isset($modvars['googlekey']) && !empty($modvars['googlekey'])) {
        $show = true;

        $iefix     = '<style type="text/css"> v\:* { behavior:url(#default#VML); } </style>';
        $mapstart  = '<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key='.$modvars['googlekey'].'" type="text/javascript"></script>';

        $pnRender->Assign('iefix',    $iefix);
        $pnRender->Assign('mapstart', $mapstart);

        $ismapped = pnModAPIFunc('GoogleMap', 'user', 'ismapped',       array());
        $markers  = pnModAPIFunc('GoogleMap', 'user', 'getall',         array());
        $specials = pnModAPIFunc('GoogleMap', 'user', 'getallspecials', array());
        if ($modvars['showusersonline']) {
            $onlines  = pnModAPIFunc('GoogleMap', 'user', 'getonlines',     array());
        }
        if ($canadd == true) {
            $handle = opendir('modules/GoogleMap/pnimages/specials');
            while ($file = readdir($handle)) {
                $filelist[] = $file;
            }
            asort($filelist);
            while (list ($key, $file) = each ($filelist)) {
                if (ereg('.png', $file)) {
                    $specialfiles .= '<option label="'.$file.'" value="'.$file.'">'.$file.'</option>';
                    //$smallfiles['small/'.$file] = $file;
                }
            }
            $pnRender->Assign('icons', $specialfiles);
        }

        $pnRender->Assign('ismapped', $ismapped);
        $pnRender->Assign('markers',  $markers);
        $pnRender->Assign('specials', $specials);
        $pnRender->Assign('onlines',  $onlines);
        $pnRender->Assign('canadd',   $canadd);
        $pnRender->Assign('islogged', pnUserLoggedIn());

    }

    $pnRender->Assign('show',     $show);
    $pnRender->Assign('modvars',  $modvars);

    return $pnRender->fetch('GoogleMap_user_main.tpl');

}

function GoogleMap_user_addme()
{

    $pnRender = new pnRender('GoogleMap');
    $pnRender->caching = false;

    $pnRender->Assign('action', 'add');

    return $pnRender->fetch('GoogleMap_user_addme.tpl');

}

function GoogleMap_user_modify()
{

    if (!pnUserLoggedIn()) {
        return pnVarPrepForDisplay(_NOTLOGGEDIN);
    }

    $item = pnModAPIFunc('GoogleMap', 'user', 'get', array('uid' => pnUserGetVar('uid')));

    if (!$item) {
        pnSessionSetVar('errormsg', 'Error retriving your info');
        return pnRedirect(pnModUrl('GoogleMap', 'user', 'main'));
    }

    $pnRender = new pnRender('GoogleMap');
    $pnRender->caching = false;

    $pnRender->Assign($item);
    $pnRender->Assign('action', 'modify');

    return $pnRender->fetch('GoogleMap_user_addme.tpl');

}

function GoogleMap_user_update()
{

    $uid        = pnVarCleanFromInput('uid');
    $action     = pnVarCleanFromInput('action');
    $longitude  = pnVarCleanFromInput('longitude');
    $latitude   = pnVarCleanFromInput('latitude');
    $msg        = pnVarCleanFromInput('msg');
    $icon       = 'marker_point.png';

    if (empty($longitude) || empty($latitude)) {
        pnSessionSetVar('errormsg', 'Wrong coordinates');
        return pnRedirect(pnModUrl('GoogleMap', 'user', 'main'));
    }

    // Check if the guy is already mapped
    if ($action == 'add') {
        $ismapped = pnModAPIFunc('GoogleMap', 'user', 'ismapped', array('uid' => $uid));
        if ($ismapped) {
            pnSessionSetVar('errormsg', 'Already mapped');
            return pnRedirect(pnModUrl('GoogleMap', 'user', 'main'));
        }
    }

    $result = pnModAPIFunc('GoogleMap', 'user', 'update', array('action'    => $action,
                                                                'uid'       => $uid,
                                                                'longitude' => $longitude,
                                                                'latitude'  => $latitude,
                                                                'msg'       => $msg,
                                                                'icon'      => $icon));

    if ($result == false) {
        //pnSessionSetVar('errormsg', 'Error updating markers');
    } else {
        pnSessionSetVar('statusmsg', _GM_COORDSUPDATED);
    }

    return pnRedirect(pnModUrl('GoogleMap', 'user', 'main'));

}

?>