<?php
/**
 * PostNuke Application Framework
 *
 * @copyright (c) 2001, PostNuke Development Team
 * @link http://www.postnuke.com
 * @version $Id: pnuserapi.php 191 2006-05-14 21:19:13Z chestnut $
 * @license GNU/GPL - http://www.gnu.org/copyleft/gpl.html
 */

function GoogleMap_userapi_getall($args)
{

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['googlemap_markers'];
    $col = $pntable['googlemap_markers_column'];

    $sql = "SELECT $col[mid],
                   $col[uid],
                   $col[lat],
                   $col[long],
                   $col[msg],
                   $col[icon]
            FROM   $tbl
            WHERE  $col[uid] >= '1'";

    $result =& $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "Error: ".$dbconn->ErrorMsg());
        return false;
    }

    $markers = array();

    for (; !$result->EOF; $result->MoveNext()) {
        list($mid, $uid, $lat, $long, $msg, $icon) = $result->fields;

        $markers[] = array('mid'        => $mid,
                           'uid'        => $uid,
                           'latitude'   => $lat,
                           'longitude'  => $long,
                           'msg'        => $msg,
                           'icon'       => $icon);

    }

    return $markers;

}

function GoogleMap_userapi_get($args)
{

    if (isset($args['objectid']) && is_numeric($args['objectid'])) {
        $args['uid'] = $args['objectid'];
        $byid = true;
    } else {
        $byid = false;
    }

    if (!isset($args['uid']) || !is_numeric($args['uid'])) {
        return false;
    }

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['googlemap_markers'];
    $col = $pntable['googlemap_markers_column'];

    if ($byid) {
        $wherecol = $col['mid'];
    } else {
        $wherecol = $col['uid'];
    }

    $sql = "SELECT $col[mid],
                   $col[uid],
                   $col[lat],
                   $col[long],
                   $col[msg],
                   $col[icon]
            FROM   $tbl
            WHERE  $wherecol = '".pnVarPrepForStore($args['uid'])."'";

    $result =& $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "Error: ".$dbconn->ErrorMsg());
        return false;
    }

    $item = array();

    list($mid, $uid, $lat, $long, $msg, $icon) = $result->fields;

    $item = array('mid'       => $mid,
                  'uid'       => $uid,
                  'latitude'  => $lat,
                  'longitude' => $long,
                  'msg'       => $msg,
                  'icon'      => $icon);

    return $item;

}

function GoogleMap_userapi_ismapped($args)
{

    if (!isset($args['uid']) || empty($args['uid'])) {
        $uid = pnUserGetVar('uid');
    } else {
        $uid = $args['uid'];
    }

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['googlemap_markers'];
    $col = $pntable['googlemap_markers_column'];

    $sql = "SELECT count($col[mid])
            FROM   $tbl
            WHERE  $col[uid] = '".pnVarPrepForStore($uid)."'";

    $result =& $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "Error: ".$dbconn->ErrorMsg());
        return false;
    }

    list($count) = $result->fields;

    if ($count == 0) {
        return false;
    } else {
        return true;
    }

}

function GoogleMap_userapi_update($args)
{

    $action     = $args['action'];
    $uid        = $args['uid'];
    $longitude  = $args['longitude'];
    $latitude   = $args['latitude'];
    $msg        = $args['msg'];
    if (isset($args['icon']) && !empty($args['icon'])) {
        $icon = $args['icon'];
        //if ($uid == -1) {
        //    $icon = 'specials/'.$icon;
        //}
    } else {
        $icon = 'marker_point.png';
    }
    if (!isset($args['title'])) {
        $title = '';
    } else {
        $title = $args['title'];
    }

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['googlemap_markers'];
    $col = $pntable['googlemap_markers_column'];

    if ($action == 'add') {

        $sql = "INSERT INTO $tbl (
                            $col[title],
                            $col[uid],
                            $col[lat],
                            $col[long],
                            $col[msg],
                            $col[icon])
                VALUES     ('".pnVarPrepForStore($title)."',
                            '".pnVarPrepForStore($uid)."',
                            '".pnVarPrepForStore($latitude)."',
                            '".pnVarPrepForStore($longitude)."',
                            '".pnVarPrepForStore($msg)."',
                            '".pnVarPrepForStore($icon)."')";

    } else {
        $sql = "UPDATE $tbl
                SET    $col[title]  = '".pnVarPrepForStore($title)."',
                       $col[lat]    = '".pnVarPrepForStore($latitude)."',
                       $col[long]   = '".pnVarPrepForStore($longitude)."',
                       $col[msg]    = '".pnVarPrepForStore($msg)."',
                       $col[icon]   = '".pnVarPrepForStore($icon)."'
                WHERE  $col[uid]    = '".pnVarPrepForStore($uid)."'";
    }

    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        //echo $dbconn->ErrorMsg(); exit;
        pnSessionSetVar('errormsg', "Error: ".$dbconn->ErrorMsg());
        return false;
    }

    return true;

}

function GoogleMap_userapi_getallspecials($args)
{

    $dbconn  =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['googlemap_markers'];
    $col = $pntable['googlemap_markers_column'];

    $sql = "SELECT   $col[mid],
                     $col[title],
                     $col[uid],
                     $col[lat],
                     $col[long],
                     $col[msg],
                     $col[icon]
            FROM     $tbl
            WHERE    $col[uid] <= '0'
            ORDER BY $col[mid]";

    $result =& $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "Error: ".$dbconn->ErrorMsg());
        return false;
    }

    $markers = array();

    for (; !$result->EOF; $result->MoveNext()) {
        list($mid, $title, $uid, $lat, $long, $msg, $icon) = $result->fields;

        $markers[] = array('mid'        => $mid,
                           'title'      => $title,
                           'uid'        => $uid,
                           'latitude'   => $lat,
                           'longitude'  => $long,
                           'msg'        => $msg,
                           'icon'       => 'specials/'.$icon);

    }

    return $markers;

}

function GoogleMap_userapi_getonlines($args)
{

    // Doing a first test to prevent from slowing the function
    // in case HostIP is unavailable
    if (@fopen('http://api.hostip.info/get_html.php', 'r')) {
        fclose($fp);
    } else {
        return false;
    }

    $dbconn =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['session_info'];
    $col = &$pntable['session_info_column'];

    $activetime = time() - (pnConfigGetVar('secinactivemins') * 60);
    $anonymous  = pnConfigGetVar('anonymous');

    $sql = "SELECT DISTINCT $col[uid],
                            $col[ipaddr]
            FROM            $tbl
            WHERE           $col[lastused] > $activetime
            GROUP BY        $col[uid], $col[ipaddr]";

    $result =& $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'Failed to get online users');
        return false;
    }

    // Obtain the number of items
    //$numusers = $result->RecordCount();
    $onlines = array();
    for (; !$result->EOF; $result->MoveNext()) {
        list($userid, $userip) = $result->fields;

        $doit = false;

        if ($userid <> 0) {
            $ismapped = pnModAPIFunc('GoogleMap', 'user', 'ismapped', array('uid' => $userid));

            if (!$ismapped) {
                $doit = true;
            } else {
                $doit = false;
            }
        } else {
            $doit = true;
        }

        $final = array();
        if ($doit && $fp = @fopen('http://api.hostip.info/get_html.php?ip='.$userip.'&position=true', 'r')) {
            $html = fread($fp, 1000000);
            fclose($fp);

            $var = explode("\n", $html);
            foreach($var as $line) {
              $tmp = explode(":", $line);

              $final[strtolower($tmp[0])] = $tmp[1];
            }
            array_walk($final, 'GoogleMap_userapi_array_walk');

            if ($userid <> 0) {
                $final['uname'] = pnUserGetVar('uname', $userid);
            } else {
                $final['uname'] = $anonymous;
            }
            $final['icon']   = 'small/mm_20_white.png';
            $final['userip'] = $userip;
        }
//print_r($final);

        if (isset($final['latitude']) && !empty($final['latitude'])) {
            $onlines[] = $final;
        }
    }

    $result->Close();
//print_r($onlines);
    return $onlines;
}

function GoogleMap_userapi_userislogged($args)
{

    if (isset($args['uid']) && is_numeric($args['uid'])) {
        return false;
    }

    $uid = $args['uid'];

    $dbconn =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    $tbl = $pntable['session_info'];
    $col = &$pntable['session_info_column'];

    $activetime = time() - (pnConfigGetVar('secinactivemins') * 60);

    $sql = "SELECT DISTINCT $col[uid],
                            $col[ipaddr]
            FROM            $tbl
            WHERE           $col[lastused] > $activetime
            AND             $col[uid]      = '".pnVarPrepForStore($uid)."'
            GROUP BY        $col[uid], $col[ipaddr]";

    $result =& $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'Failed to get online users');
        return false;
    }

    if ($result->EOF) {
        return false;
    }

    $result->Close();

    return true;

}

function GoogleMap_userapi_getfromhostip($args)
{

    if (isset($args['uid']) && is_numeric($args['uid'])) {
        $uid = $args['uid'];
    } else {
        $uid = pnUserGetVar('uid');
    }

//    if ($uid < 2) {
//        $ismapped = pnModAPIFunc('GoogleMap', 'user', 'ismapped', array('uid' => $uid));
//    } else {

    $userip = pnServerGetVar('REMOTE_ADDR');
    if (empty($userip)) {
        $userip = pnServerGetVar('HTTP_CLIENT_IP');
    }
    $tmpipaddr = pnServerGetVar('HTTP_CLIENT_IP');
    if (!empty($tmpipaddr)) {
        $userip = $tmpipaddr;
    }

    if ($fp = @fopen('http://api.hostip.info/get_html.php?ip='.$userip.'&position=true', 'r')) {
        $html = fread($fp, 1000000);
        fclose($fp);
        $var = explode("\n", $html);
        foreach($var as $line) {
          $tmp = explode(":", $line);
          $final[strtolower($tmp[0])] = $tmp[1];
        }
        array_walk($final, 'GoogleMap_userapi_array_walk');
        if ($userid > 1) {
            $final['uname'] = pnUserGetVar('uname', $userid);
        } else {
            $final['uname'] = $anonymous;
        }

        if (!isset($final['latitude']) || !empty($final['latitude'])) {
            return false;
        }

        $final['icon']   = 'small/mm_20_white.png';
        $final['userip'] = $userip;

    } else {
        return false;
    }

}

function GoogleMap_userapi_array_walk(&$value)
{

    $value = trim($value);

}

function GoogleMap_userapi_temp()
{

    return true;

}

?>